package com.zsc.edu.gateway.modules.iot.tsl.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zsc.edu.gateway.modules.iot.product.dto.ProductDto;
import com.zsc.edu.gateway.modules.iot.product.entity.ProductParam;
import com.zsc.edu.gateway.modules.iot.product.repo.ProductParamRepository;
import com.zsc.edu.gateway.modules.iot.tsl.dto.ParamDto;
import com.zsc.edu.gateway.modules.iot.tsl.dto.ServeDto;
import com.zsc.edu.gateway.modules.iot.tsl.entity.EventParam;
import com.zsc.edu.gateway.modules.iot.tsl.entity.Param;
import com.zsc.edu.gateway.modules.iot.tsl.entity.ServeParam;
import com.zsc.edu.gateway.modules.iot.tsl.mapper.ParamMapper;
import com.zsc.edu.gateway.modules.iot.tsl.repo.EventParamRepository;
import com.zsc.edu.gateway.modules.iot.tsl.repo.ParamRepository;
import com.zsc.edu.gateway.modules.iot.tsl.repo.ServeParamRepository;
import com.zsc.edu.gateway.modules.iot.tsl.service.ParamService;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

/**
 * @author zhuang
 */
@AllArgsConstructor
@Service
public class ParamServiceImpl extends ServiceImpl<ParamRepository, Param> implements ParamService {
    private final ParamMapper mapper;
    private final ParamMapper paramMapper;
    private final EventParamRepository eventParamRepository;
    private final ProductParamRepository productParamRepository;
    private final ServeParamRepository serveParamRepository;

    @Override
    public List<Long> paramCreate(List<ParamDto> params) {
        List<Long> paramIds = new ArrayList<>();
        List<Param> paramsToInsert = params.stream()
                .map(mapper::toEntity)
                .collect(Collectors.toList());
        baseMapper.insert(paramsToInsert);
        paramsToInsert.forEach(param -> paramIds.add(param.getId()));
        return paramIds;
    }

    @Override
    public boolean paramUpdate(List<ParamDto> paramDto, List<Long> paramIds) {
        List<Param> params = baseMapper.selectByIds(paramIds);
        if (!params.isEmpty() && !paramDto.isEmpty()) {
            List<Param> updatedParams = IntStream.range(0, Math.min(params.size(), paramDto.size()))
                    .parallel()
                    .mapToObj(i -> {
                        Param param = params.get(i);
                        ParamDto dto = paramDto.get(i);
                        paramMapper.convert(dto, param);
                        return param;
                    })
                    .collect(Collectors.toList());
            baseMapper.updateById(updatedParams);
        }
        return true;
    }

    //TODO 整合方法？方法一：保持现状，但是会有多个联表多个entity多个repo？方法二：建新联表其中values(product_id,serve_id,event_id,param_id)一表联三表
}
